ความคิดเห็น •

  • @NeetCode
    @NeetCode 3 ปีที่แล้ว +25

    🚀 neetcode.io/ - A better way to prepare for Coding Interviews

    • @serioussam2071
      @serioussam2071 8 หลายเดือนก่อน

      @NeetCode make a video on Manachar's algo. I couldn't wrap my head around it

  • @devonfulcher
    @devonfulcher 3 ปีที่แล้ว +525

    Wouldn't this solution be O(n^3) because s[l:r+1] could make a copy of s for each iteration? An improvement would be to store the indices in variables like res_l and res_r when there is a larger palindrome instead of storing the string itself in res. Then, outside of the loops, return s[res_l:res_r].

    • @NeetCode
      @NeetCode 3 ปีที่แล้ว +289

      Good catch! you're exactly correct, and your proposed solution would be O(n^2). I hope the video still explains the main idea, but thank you for pointing this out. I will try to catch mistakes like this in the future.

    • @shivakumart7269
      @shivakumart7269 3 ปีที่แล้ว +12

      Hey Devon Fulcher, Hii, if you don't mind can you please share your code, it would increase my knowledge in approaching these huge time complexity questions

    • @devonfulcher
      @devonfulcher 3 ปีที่แล้ว +2

      @@shivakumart7269 Here you go leetcode.com/problems/longest-palindromic-substring/discuss/1187935/Storing-string-indices-vs.-using-substring! My small fix doesn't seem to make the runtime much faster in terms of ms but it is more correct in terms of algorithmic complexity.

    • @shivakumart7269
      @shivakumart7269 3 ปีที่แล้ว +3

      @@devonfulcher It says, topic does not exist

    • @beary58
      @beary58 2 ปีที่แล้ว +10

      Hi Devon, do you mind explaining why s[l:r + 1] would result in a O(N^3)? How does making a copy of s for each iteration make the solution worse? Thank you.

  • @rishabhjain4546
    @rishabhjain4546 3 ปีที่แล้ว +20

    I looked at solutions from other people, but your explanation was the. best. In 8 mins, you explained a 30 min solution.

  • @sowbaranikab1302
    @sowbaranikab1302 ปีที่แล้ว +3

    Thanks for the amazing explanation. I also have a quick comment. In the while loop, we can add a condition to exit the loop once the resLen variable reaches the maximum Length(len(s)). By doing this, we can stop the iteration once the given entire string is a palindrome and skip iterating through the right indices as the middle element. [while l>=0 and r< len(s) and s[l] == s[r] and resLen!=len(s)]:

  • @doodle_pug
    @doodle_pug 3 ปีที่แล้ว +7

    I've been scratching my head on this problem for a few days thank you for your clean explanation and video!

  • @derek4951
    @derek4951 3 ปีที่แล้ว +141

    Love your vids. I swear you're the best leetcode tutorial out there. You get to the point and are easy to understand.

    • @mike19558
      @mike19558 3 ปีที่แล้ว +2

      It's also super useful that he explains the time complexity of the solutions.

    • @littlebox4328
      @littlebox4328 2 ปีที่แล้ว +1

      man I have the exact feeling!!!

    • @mama1990ish
      @mama1990ish 2 ปีที่แล้ว +5

      I only check this one channel for all questions

    • @navadeepiitbhilai9470
      @navadeepiitbhilai9470 ปีที่แล้ว

      time complexity = O(|s|^2)
      spcae complexity = O(1)
      class Solution {
      private:
      string expandAroundCenter(string s, int left, int right) {
      int n = s.length();
      while (left >= 0 && right < n && s[left] == s[right]) {
      left--;
      right++;
      }
      return s.substr(left + 1, right - left - 1);
      }
      public:
      string longestPalin (string S) {
      int n = S.length();
      if (n < 2) {
      return S;
      }
      string longestPalindrome = S.substr(0, 1); // default to the first character
      for (int i = 0; i < n - 1; i++) {
      string palindromeOdd = expandAroundCenter(S, i, i);
      if (palindromeOdd.length() > longestPalindrome.length()) {
      longestPalindrome = palindromeOdd;
      }
      string palindromeEven = expandAroundCenter(S, i, i + 1);
      if (palindromeEven.length() > longestPalindrome.length()) {
      longestPalindrome = palindromeEven;
      }
      }
      return longestPalindrome;
      }
      };

  • @Mohib3
    @Mohib3 2 ปีที่แล้ว

    You are the GOAT. Any leetcode problem I come here and 95% of time understand it

  • @matthewsarsam8920
    @matthewsarsam8920 2 ปีที่แล้ว +7

    Good explanation! I thought the palindrome for the even case would be a lot more complicated but you had a pretty simple solution to it great vid!

  • @inikotoran
    @inikotoran 2 ปีที่แล้ว +2

    I was using while left in range(len(s)) and it definitely make my solution hit the time limit. Able to pass the test cases after change it to left > 0. Thanks Neet!

  • @federicoestape4111
    @federicoestape4111 3 ปีที่แล้ว +32

    This was definitely the best way to finish my day, with an AWESOME explanation

  • @symbol767
    @symbol767 2 ปีที่แล้ว +2

    Thanks this is definitely a different kind of solution, especially for a dynamic programming type problem but you explained it and made it look easier than the other solutions I've seen.
    Also for people wondering, the reason why he did if (r - l + 1), think about sliding window, (windowEnd - windowStart + 1), this is the same concept, he is getting the window size aka the size of the palindrome and checking if its bigger than the current largest palindrome.

  • @rodrigoferrari8314
    @rodrigoferrari8314 2 ปีที่แล้ว +1

    I like when you post that it took time to you also to solve it, many people, including me, we get scaried if we do not solve it fast as "everybody does"!! Thanks again.

  • @mostinho7
    @mostinho7 11 หลายเดือนก่อน +10

    Thanks (this isn’t a dynamic programming problem but it’s marked as dynamic programming on neetcode website)
    TODO:- take notes in onenote and implement
    Trick is to expand outward at each character (expanding to the left and right) to check for palindrome. BAB if you expand outward from A you will check that left and right pointers are equal, while they’re equal keep expanding. WE DO THIS FOR EVERY SINGLE INDEX i in the string.
    BUT this checks for odd length palindromes, we want to also check for even length so we set the left pointer to i and the right pointer to i+1 and continue expanding normally.
    For index i set L,R pointers to i then expand outwards, and to check for even palindrome substrings set L=i, R=i+1

    • @felixthea
      @felixthea 8 หลายเดือนก่อน

      This can be solved with dp though

    • @samuraijosh1595
      @samuraijosh1595 8 หลายเดือนก่อน

      @@felixtheaeven faster?

    • @satyamkumarjha8152
      @satyamkumarjha8152 5 หลายเดือนก่อน

      @@samuraijosh1595 yes,the solution proposed in this video takes n^3 time complexity whereas the solution using dp takes only n^2

    • @EE12345
      @EE12345 2 หลายเดือนก่อน

      @@satyamkumarjha8152 DP is o(n^2) time and space, the most optimal solution is the algorithm in this video except saving L, R indices of res instead of the whole string, which is o(n^2) time and o(1) space

  • @enriquedesarrolladorpython
    @enriquedesarrolladorpython ปีที่แล้ว +35

    Hi everybody I want to share the answer to this problem using dp, the code is well commented (I hope), also congrats @NeetCode for his excellent explanations
    def longest_palindromic_substring(s):
    n = len(s)
    if n == 1:
    return s
    dp = [[False] * n for _ in range(n)]# 2D array of n x n with all values set to False
    longest_palindrome = ""

    # single characters are palindromes
    for i in range(n):
    dp[i][i] = True
    longest_palindrome = s[i]

    # check substrings of length 2 and greater
    for length in range(2, n+1): # size of the window to check
    for i in range(n - length + 1): # iteration limit for the window
    j = i + length - 1 # end of the window
    if s[i] == s[j] and (length == 2 or dp[i+1][j-1]):
    # dp[i+1][j-1] this evaluates to True if the substring between i and j is a palindrome
    dp[i][j] = True # set the end points of the window to True
    if length > len(longest_palindrome):
    longest_palindrome = s[i:j+1] # update the longest palindrome

    return longest_palindrome
    print(longest_palindromic_substring("bananas"))
    # Output: 'anana'
    # The time complexity of this solution is O(n^2) and the space complexity is O(n^2).

    • @shakthi6351
      @shakthi6351 11 หลายเดือนก่อน +1

      Thanks, this is what i came for.

  • @marvinxu2950
    @marvinxu2950 2 ปีที่แล้ว

    I've watched several video solution on this problem and yours is the easiest to understand. Thanks a lot!

  • @Obligedcartoon
    @Obligedcartoon 2 ปีที่แล้ว +2

    For me it was the separating out of even versus odd checking. I was moving my pointers all at once, thus missing the edge case where longest length == 2 (e.g. 'abcxxabc'). While separating out duplicates code, it does do the trick.

  • @diludhillonz
    @diludhillonz 2 ปีที่แล้ว +2

    Great explanation. I was struggling with this one even after looking at answers.

  • @calvinlai3354
    @calvinlai3354 3 ปีที่แล้ว +8

    really enjoy your content, super informative! keep them coming

  • @brandonwie4173
    @brandonwie4173 2 ปีที่แล้ว +5

    Just like another guy said, his explanation is well packed, straight to the point. Please keep up the good work. 🔥🔥🔥

  • @jiahaoguo8882
    @jiahaoguo8882 3 ปีที่แล้ว +3

    Thank you! Great work and very clear explanation.

  • @amandatao9622
    @amandatao9622 2 ปีที่แล้ว

    Your explanation saved my life!!! Thank youuuu! I like how you explain you look at this question.

  • @supercarpro
    @supercarpro 2 ปีที่แล้ว

    thanks neetcode you're out here doing holy work

  • @_ipsissimus_
    @_ipsissimus_ 2 ปีที่แล้ว

    an actual beast. i had to look up the list slicing because i thought the [:stop:] value was inclusive. thanks for the great content

  • @jacqueline1874
    @jacqueline1874 3 ปีที่แล้ว +19

    you're my leetcode savior!

    • @NeetCode
      @NeetCode 3 ปีที่แล้ว +3

      Haha I appreciate it 😊

  • @mehmetnadi8930
    @mehmetnadi8930 ปีที่แล้ว

    thanks for being honest and telling us that it took you a while to figure this out. It is empowering ngl

  • @netraamrale3850
    @netraamrale3850 2 ปีที่แล้ว +1

    Tons of thanks for making these videos. This is really very helpful and video explanation is very nice . optimize and concise

  • @rjtwo5434
    @rjtwo5434 2 ปีที่แล้ว

    Thank you for this! Great concise explanations. Subscribed!

  • @chuckchen2851
    @chuckchen2851 2 ปีที่แล้ว

    Amazingly neat solution and enlightening explanation as always!

  • @frzhouu2676
    @frzhouu2676 2 ปีที่แล้ว

    Such amazing code. I have same idea as yours but unable to write such a concise code. AWESOME

  • @aryanyadav3926
    @aryanyadav3926 2 ปีที่แล้ว

    Wow! Just love the way you explain.

  • @Lucas-nz6qt
    @Lucas-nz6qt 2 หลายเดือนก่อน

    Thanks for the amazing explanation!
    I managed to double the performance by doing this: While iterating s, you can also check if s itself is a palindrome, and if so, you don't need to iterate the other half of it (since s will be the largest palindrome, and therefore be the answer).

  • @richiejang7820
    @richiejang7820 3 ปีที่แล้ว

    Thank you for sharing a good idea. I am so enjoying to learn.

  • @edwythefair5215
    @edwythefair5215 2 ปีที่แล้ว +1

    Thanks, that was a super easy explanation!💖

  • @JohnWickea
    @JohnWickea 9 หลายเดือนก่อน

    thank you soo much , i was struggling for a long for this problem . peace finally .
    Again thanks ❤

  • @aniketsinha2826
    @aniketsinha2826 2 ปีที่แล้ว

    i don't know ...how i will thanks to you for such wonderful videos !! appreciated

  • @varunkamath215
    @varunkamath215 2 ปีที่แล้ว

    Great explanation and easy to understand. Thanks for the video

  • @sulavasingha
    @sulavasingha ปีที่แล้ว

    One of the best explaination so far

  • @masc0648
    @masc0648 7 หลายเดือนก่อน

    Thank you Neetcode for this video.

  • @illu1na
    @illu1na 8 หลายเดือนก่อน +2

    This is two pointer problem instead of DP problem no?
    It doesn't really solve subproblem and does not have recurrence relationship. The category in the Neetcode Roadmap got me. I spent quite a while trying to come up with the recurrence function but no avail :D

    • @gradientO
      @gradientO 8 หลายเดือนก่อน

      The way I solved it to create a dp table. The function is
      dp[i,j] = true if i == j
      Else true if s[i] == s[j] and inner substring is a plaindrome too (i e dp[i+1][j-1]

  • @khangmach5369
    @khangmach5369 ปีที่แล้ว

    I see acceptance rate of this question making me nervous, but see your explanation make me feel relieved :)

  • @Mad7K
    @Mad7K 2 ปีที่แล้ว

    what i did was expand the center first( find the cluster of the center character - "abbba", in the given example find the index of the last b), then expand the edges, that way its irrelevant if its even or odd, each iteration will start from the next different character.

  • @alifarooq9207
    @alifarooq9207 2 ปีที่แล้ว

    Great explanation! By far the best solution.

  • @kartiksoni5877
    @kartiksoni5877 2 ปีที่แล้ว

    Amazing way to simmplify the problem

  • @sharad_dutta
    @sharad_dutta 2 ปีที่แล้ว

    Very nice approach, thanks.

  • @wintersol9921
    @wintersol9921 8 หลายเดือนก่อน

    You are the best, thanks for this explanation, its very clear.

  • @abhishekshrivastav6193
    @abhishekshrivastav6193 ปีที่แล้ว

    Amazing solution you have made.

  • @Sethsm1
    @Sethsm1 2 ปีที่แล้ว

    Great explanation, as usual!

  • @aashishupadhyay5566
    @aashishupadhyay5566 3 ปีที่แล้ว

    hey buddy u earned my subs!! your explanation is very awesome keep going love your content😘

  • @dominicxavier3128
    @dominicxavier3128 ปีที่แล้ว

    I think this solution is crazy - crazy awesome!

  • @AliMalik-yt5ex
    @AliMalik-yt5ex ปีที่แล้ว

    Got this question in Leetcode's mock online assessment and had no idea that it was a medium. I didn't even know where to begin. I guess I still need to keep doing easy before I move on to the mediums.

  • @ilanaizelman3993
    @ilanaizelman3993 2 ปีที่แล้ว

    Perfect. Thank you!

  • @BadriBlitz
    @BadriBlitz 3 ปีที่แล้ว

    Brilliant Explanation bro. You got a new subscriber.Great job.

    • @NeetCode
      @NeetCode 3 ปีที่แล้ว +2

      Thanks, glad it was helpful

  • @dangbey4822
    @dangbey4822 10 หลายเดือนก่อน

    best solution ever, thnx for making it looks easy

  • @ahmed749100
    @ahmed749100 ปีที่แล้ว

    You saved my day :D, thanks.

  • @Yosso117
    @Yosso117 ปีที่แล้ว

    Братан, хорош, давай, давай, вперёд! Контент в кайф, можно ещё? Вообще красавчик! Можно вот этого вот почаще?

  • @danielsun716
    @danielsun716 2 ปีที่แล้ว

    For neetcode solution, I think we could set an expanded step to cache the longest palindrome we have found for improving. Cause if we have found a 3 length palindrome already, then we do not have to do it again. I believe that gonna save a lot of time.

  • @self-learning1824
    @self-learning1824 2 ปีที่แล้ว

    Awesome content!! Kudos :)

  • @xintu8123
    @xintu8123 ปีที่แล้ว

    This one doesn't seem to be related much to the dynamic programming stuff.. the most intuitive way to me is the same, expanding from the centre part. Thanks for your video man, it is the clearest implementation I have ever met. I implemented with the same idea, but stumble a lot and ended up with a long code(maybe because I was using pure C.. xD)

  • @swaggerlife
    @swaggerlife ปีที่แล้ว

    Thank you very much for your videos mate. Just wondering what software you are using to draw on? it looks very nice.

  • @yilmazbingol4838
    @yilmazbingol4838 2 ปีที่แล้ว +27

    Why is this considered to be a dynamic programming example?

    • @anishkarthik4309
      @anishkarthik4309 11 หลายเดือนก่อน

      It is

    • @DJ-lo8qj
      @DJ-lo8qj 11 หลายเดือนก่อน +2

      Great question, I’m wondering the same

    • @hasansihab3555
      @hasansihab3555 9 หลายเดือนก่อน +2

      There is a DP way to do it you can put all the substrings in a dp table and check for if it’s palindrome

    • @Briansilasluke
      @Briansilasluke 9 หลายเดือนก่อน +2

      This solution is without dp, it can be solved with dp too but this isn’t it

    • @Dermotten
      @Dermotten 3 หลายเดือนก่อน

      I had the same question. The reason it can be considered DP is because when we expand outwards by one character, the check for whether it's a palindrome is O(1) because we rely on the previous calculation of the inner string of characters. Relying on a previous calculation like that is the basis of dynamic programming. This optimization is critical as it brings the solution down from O(n^3) to O(n^2).

  • @arnabpersonal6729
    @arnabpersonal6729 2 ปีที่แล้ว +7

    But unfortunately string slice operation would also cost linear time as well so u can store the range index instead of updating the res with string everytime

  • @CodeReviewer
    @CodeReviewer 2 ปีที่แล้ว +1

    Your explanations to the hard problems are the best.

  • @ausumnviper
    @ausumnviper 2 ปีที่แล้ว

    Great explanation !!

  • @mojojojo1211
    @mojojojo1211 ปีที่แล้ว

    your solutions are easier than the one on leetcode premium. smh. Thanks a lot! may god bless you!

  • @dbappz8293
    @dbappz8293 2 หลายเดือนก่อน

    damn i need more than 1 days to solve it with brute force technique, and when you said we can check it from the middle and will save so much time, i think... amazing you're right, how can im not thinking about that..

  • @mohammadrahman8985
    @mohammadrahman8985 2 ปีที่แล้ว

    Beautiful Solution

  • @mohit8299
    @mohit8299 ปีที่แล้ว

    Thanks for the solution

  • @chloexie6576
    @chloexie6576 2 ปีที่แล้ว +1

    thanks for your explanation. my comment: instead of updating the resLen, you might just use len(res) to check for each if condition

  • @ac9h482
    @ac9h482 3 ปีที่แล้ว

    Great explanation

  • @MadpolygonDEV
    @MadpolygonDEV ปีที่แล้ว

    I am pretty sure my duct tape solution is O(N^3) but it still barely made the Time limit so I am here checking how one could solve it better. Making a center pivot and growing outwards is a very elegant solution indeed

  • @shrimpo6416
    @shrimpo6416 2 ปีที่แล้ว +5

    I tried so hard with recursive calls and cache, thank you for the explanation! I wonder why I never come up with that clever idea though. I thought about expanding out from the center, but I was trying to find "the center (of answer)" and expand out only once.

    • @aat501
      @aat501 2 ปีที่แล้ว +3

      i like your username

    • @shrimpo6416
      @shrimpo6416 2 ปีที่แล้ว +4

      @@aat501 Thank you! And my cousin Lobstero should feel equally flattered :)

  • @rotichbill637
    @rotichbill637 2 ปีที่แล้ว

    This content is way better than LeetCode premium

  • @dera_ng
    @dera_ng 2 ปีที่แล้ว +4

    Hello neetcode, thanks for all the AMAZING work you do here. I've been trying to come up with a solution of my own for this question and it's been sad to say the least. I tried coming up with a solution of my own because even if your solutions (especially the brute for solution) makes sense, the time complexity O(n^3) is scary. In short, it's the firs time I've ever seen a problem that could ever have such time complexities.
    I actually saw this problem on leetcode before even knowing you had solved it before. So I would like to ask, do you think it's fine "learning" the brute force approach and trying the brute force approach first for all problems? Or do you just start with an optimised solution? I'm asking because it's tempting to try out a more efficient approach or a better data structure than when you try to do so with brute force. I also find myself having tunnel vision at times when I am trying the brute force approach.
    Thank you so much for everything you do here again and I really hope you could ever respond to this :)

  • @sauravdeb8236
    @sauravdeb8236 2 ปีที่แล้ว +1

    He is giving us quality explanations for free. Hats off. Let me get a job then I will buy you a coffee.

  • @asdfasyakitori8514
    @asdfasyakitori8514 8 หลายเดือนก่อน

    Great video!

  • @Angx_only
    @Angx_only ปีที่แล้ว +2

    If the input is "ac", the answer will go wrong due to the result should be "a" or "c". This question should point out whether a single letter can be a palindrome.

  • @travisc9436
    @travisc9436 3 ปีที่แล้ว +1

    Thanks for giving the bit of insight to your struggles...lets us know your human ;)

  • @davidespinosa1910
    @davidespinosa1910 3 หลายเดือนก่อน +1

    On the Neetcode Practice page, this problem is listed as 1-D Dynamic Programming. But this video doesn't use DP at all. Also, 1-D DP yields an O(n) solution, if we can calculate each table entry in constant time. But the solution in this video is O(n^2).

    • @o3_v3
      @o3_v3 หลายเดือนก่อน

      I'm glad to see that I'm not the only one confused here.

  • @vishetube
    @vishetube 7 หลายเดือนก่อน +1

    hey neet code for the even string "adam" "ada" forms a palliamdrom; I could not get the code the work with this logic for even length string with substrings having palliandrome. Also how is l,r set to the middle when you are setting the index to start at 0?

  • @sasbazooka
    @sasbazooka ปีที่แล้ว

    Really cool video, thanks for walking through it. Question: Is there a reason to track resLen or would it be just as efficient to use len(res) instead?

    • @anusha3598
      @anusha3598 ปีที่แล้ว

      yes cuase this value is being updated everytime if there is a value that is bigger than what this var is already is havng uptill that point

  • @stith_pragya
    @stith_pragya 3 หลายเดือนก่อน +1

    Thank You So Much for this wonderful video...............🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻

  • @meeradad
    @meeradad 3 หลายเดือนก่อน

    Love the solution. I was wondering why this is under a "dynamic programming" category. I thought that dynamic programming should have some version of updating one or more values in one iteration that are then used in some other iteration. Having found a longest palindromic string upto a value of the center index, we do not seem to have a reason for using that information at another value of a center index.

  • @manoranjan3705
    @manoranjan3705 ปีที่แล้ว

    good one bruh❤️

  • @vijaykirans1712
    @vijaykirans1712 2 ปีที่แล้ว

    i dont think i have a seen easier way to get this .. i always struggle with the dp 2d array and make mistake .. thanks for making it clear 👍🏻

  • @Dhruvbala
    @Dhruvbala 12 วันที่ผ่านมา +1

    Wait, why is this classified as a DP problem? Your solution was my first thought -- and what I ended up implementing, thinking it was incorrect.

  • @HardikJain_YT
    @HardikJain_YT หลายเดือนก่อน

    smooth af

  • @raghavendharreddydarpally2125
    @raghavendharreddydarpally2125 3 ปีที่แล้ว

    Awesome !!

  • @xx133
    @xx133 5 หลายเดือนก่อน

    I was hoping you’d explain manacher’s algorithm.😢 also, you can insert a character in between each letter to ensure it’s always odd length, you just have to account for that in the output

  • @vantran321
    @vantran321 2 ปีที่แล้ว +1

    Damn daddy you really out here holding it down for us

  • @victorvelmakin9907
    @victorvelmakin9907 2 ปีที่แล้ว +3

    Very good solution.
    If you add at the beginning of for loop the line "if resLen > 0 and len(s) - i - 1 < resLen // 2 : break" you will speed up the algorithm faster than 90 % submissions and get a runtime of about 730 ms. The idea is if you already have the palindrome you don't have to loop till the end of "s". You can break the loop after the distance till the end of "s" is less than resLen / 2.

    • @bidishadas832
      @bidishadas832 2 ปีที่แล้ว

      This helped me avoid TLE in leetcode.

    • @krishnanspace
      @krishnanspace 5 หลายเดือนก่อน

      But what if after looping till the end, the palindrome is of bigger length?

  • @avanidixit7181
    @avanidixit7181 ปีที่แล้ว

    how would it get whether the string will go in first while loop or second while loop as no condition is mentioned for checking even or odd length . I am not able to get it

  • @luckychitundu1070
    @luckychitundu1070 2 ปีที่แล้ว +1

    Was helpful

  • @ilham7555
    @ilham7555 2 ปีที่แล้ว

    Thanks!

  • @IsomerMashups
    @IsomerMashups 3 ปีที่แล้ว +4

    Wait a minute. I've been so conditioned to think O(n^2) is unacceptable that I didn't even consider that my first answer might be acceptable.

  • @sidazhong2019
    @sidazhong2019 2 ปีที่แล้ว

    I like the way he said "but I am too lazy to do it"

  • @charanreddy5227
    @charanreddy5227 4 หลายเดือนก่อน

    You are the best guy

  • @lovleenkaur1042
    @lovleenkaur1042 3 ปีที่แล้ว

    Precise and Clear content. Thanks a lot.

  • @jamesmnpl
    @jamesmnpl 2 ปีที่แล้ว

    you are an awesome software engineer. Team whos working with you would be so lucky to have you dude.

  • @AmolGautam
    @AmolGautam 2 ปีที่แล้ว

    Thank you

  • @dhruvsakariya3129
    @dhruvsakariya3129 10 หลายเดือนก่อน

    very clear